<template lang="html">
  <div class="">
    <div class="level">
      <div class="level-left">
      </div>
      <div class="level-right">
        <div class="level-item">
          <export-label />
        </div>
        <div class="level-item">
          <import-label />
        </div>
        <div class="level-item">
          <button class="button" @click="showConfigToggle">Config</button>
        </div>
      </div>
    </div>
    <hr />

    <transition name="slide-fade">
      <processing-config v-show="showConfig" />
    </transition>

    <div class="level">
      <div class="level-left">
        <div class="level-item">
          <button class="button is-primary" @click.stop="loadDataWithoutUpload">Load Raw Data</button>
        </div>
        <div class="level-item">
          <button class="button is-danger" @click.stop="processRawImages">Process Data</button>
        </div>
        <div class="level-item">
          <button class=" button is-primary" @click.stop="loadProcessedData">Load Processed Data</button>
        </div>
        <slot>
          <!-- slot untuk training atau testing -->
        </slot>
      </div>
    </div>
    <hr />
  </div>
</template>

<script>
import ExportLabel from '@/components/base/ExportLabel'
import ImportLabel from '@/components/base/ImportLabel'
import processingConfig from '@/components/base/ProcessingConfig'
const STATUS_PROCESSING = 4, STATUS_PROCESSED = 5, STATUS_TRAINING = 6, STATUS_TRAINED = 7


export default {
  components: {ExportLabel, ImportLabel, processingConfig},
  data() {
    return {
      showConfig: false
    }
  },
  methods: {
    showConfigToggle() {
      this.showConfig = !this.showConfig
    },
    processRawImages() {
      // const command = new FormData()
      const command = []
      const imageList = this.$store.state.images._items

      for (var i = 0; i < imageList.length; i++) {
        command.push({
          command: 'process_image',
          scope: ['single'],
          ref_id: imageList[i]._id
        })
      }
      this.currentStatus(STATUS_PROCESSING)
      this.$store.dispatch('processImages', command)
      // this.$forceUpdate()
    },
    currentStatus(status) {
      return this.$store.commit(
        'setCurrentStatus',
        {currentStatus: status}
      )
    },
    loadDataWithoutUpload() {
      this.$store.commit('setCurrentStatus', {currentStatus: 10})
      this.$store.dispatch('loadImages', {
        where: {is_processed: false, is_trained: false},
        projection: {detected: 0, step_processed: 0}
      }).then(()=> this.$store.commit('setCurrentStatus', {currentStatus: 2}))
    },
    loadProcessedData() {
      this.$store.commit('setCurrentStatus', {currentStatus: 10})
      this.$store.dispatch('loadImages', {
        where: {is_processed: true, is_trained: false},
        projection: {step_processed: 0}
      }).then((response) => this.$store.commit('setCurrentStatus', {currentStatus: 5}))
    }
  }
}
</script>

<style lang="scss" scoped="">
  .slide-fade-enter-active {
    transition: all .3s ease;
  }
  .slide-fade-leave-active {
    transition: all .3s ease;
  }
  .slide-fade-enter, .slide-fade-leave-to {
    transform: translateY(-100px);
    opacity: 0;
  }
</style>
